import { Abi } from "../abi";
import { BaseController, BaseControllerInput, IAccount, SmartContractQuery, SmartContractQueryInput, SmartContractQueryResponse, Transaction, TransactionOnNetwork } from "../core";
import { INetworkProvider } from "../networkProviders/interface";
import * as resources from "./resources";
export declare class SmartContractController extends BaseController {
    private factory;
    private parser;
    private transactionWatcher;
    private networkProvider;
    private abi?;
    constructor(options: {
        chainID: string;
        networkProvider: INetworkProvider;
        abi?: Abi;
    });
    createTransactionForDeploy(sender: IAccount, nonce: bigint, options: resources.ContractDeployInput & BaseControllerInput): Promise<Transaction>;
    parseDeploy(transactionOnNetwork: TransactionOnNetwork): resources.SmartContractDeployOutcome;
    awaitCompletedDeploy(txHash: string): Promise<resources.SmartContractDeployOutcome>;
    createTransactionForUpgrade(sender: IAccount, nonce: bigint, options: resources.ContractUpgradeInput & BaseControllerInput): Promise<Transaction>;
    createTransactionForExecute(sender: IAccount, nonce: bigint, options: resources.ContractExecuteInput & BaseControllerInput): Promise<Transaction>;
    parseExecute(transactionOnNetwork: TransactionOnNetwork): resources.ParsedSmartContractCallOutcome;
    awaitCompletedExecute(txHash: string): Promise<resources.ParsedSmartContractCallOutcome>;
    query(options: SmartContractQueryInput): Promise<any[]>;
    runQuery(query: SmartContractQuery): Promise<SmartContractQueryResponse>;
    createQuery(options: SmartContractQueryInput): SmartContractQuery;
    private raiseForStatus;
    parseQueryResponse(response: SmartContractQueryResponse): any[];
    private encodeArguments;
    private areArgsOfTypedValue;
    private areArgsBuffers;
}
